

%----------------------------------------
function VisTwo(mask, M, iteration)
%----------------------------------------

global interpol_num; %interpol_num=0 in case the function is not interpolating,
                     %interpol_num=1 in case the function is interpolating
global big_ev;       %big_ev is the eigenvector to the largest eigenvalue of
                     %the matrix As (calculated in the program doTwo.m) 
global fileName;     %the filename of the chosen mask


h_h=findobj('Tag','TextBox');


if (isempty(big_ev)) 
  T_T={'Please press "Go!"-button first!!!'};
  text_out(T_T);
else

  %---Visualisation of the scaling function

  %Checking the dilation matrix:
  DM1=[1 -1; 1 1];
  DM2=[2 0 ; 0 2]; 
  if sum(sum(abs(M-DM1)))~=0 & sum(sum(abs(M-DM2)))~=0
     T_T={'The visual program is only available for dilation matrices:' 
       '             [2   0]            [1 -1]' 
       '             [0   2]            [1   1]'}; 

    text_out(T_T); 
  end


  %---Visualisation of the scaling function for matrix M=[1 -1; 1 1]

%Checking the dilation matrix:
if (sum(sum(abs(M-DM1)))==0)
  dm=det(M);

   %Parameters:
   n=max(max(abs(mask(:,1))),max(abs(mask(:,2))));
   s=n+1;
   N=2*s-1;
   l=length(mask(:,1));

   %Checking for normalization:
   if sum(mask(:,3)) ~= 1 
	dm=1;
   end

   %Mask of coefficients:
   A=zeros(N);
   for i=1:l
        A(mask(i,2)+s,mask(i,1)+s) = mask(i,3)*dm;
   end
   A;

clear mask;


%Defining phi_0:

%If the scaling function is interpolating then one has to use:
if (interpol_num==1)
  dim=N;
  B2=zeros(dim);
  B2((dim-1)/2+1,(dim-1)/2+1)=1; 
  size(B2);
  B2;
end


%If the scaling function is not interpolating then one has to use the largest eigenvalue:
if (interpol_num==0)
  load 'EV.mat'
  length(big_ev);
  dim=sqrt(length(big_ev));
  B2=zeros(dim);
  for i=1:dim
    for j=1:dim
	B2(i,dim-j+1)=big_ev(j+(i-1)*dim);
    end
  end
  size(B2); 
  B2;
end

clear big_ev;

%Calculation 

check1=0;
check2=0;
m=(dim-1)/2;
sm=m+1;


for it=1:iteration 
   T_T(1)={sprintf('Computing iteration number %1.0f of the visual program...',it)};

   if (it>=2) 
     T_T(2)={'   '};
     T_T(3)={'   Information: '};
     T_T(4)={'-----------------------------------------------------------'};
     T_T(5)={sprintf('* Time needed for iteration number %1.0f:',it-1)};
     T_T(6)={sprintf('   %6.6f minutes.',t/60)};
     b_it=size(B1,1);
     time_it=(2*b_it)^2/(b_it^2)*(t/60); 
     T_T(7)={sprintf('* The computation of iteration number %1.0f will take about:',it)};
     T_T(8)={sprintf('  %6.3f minutes.',time_it)};
   end
   text_out(T_T);
   pause(1);
   B1=B2;
   size(B1);
   clear B2;
   clear t;
   fac1=2^(-it);
   fac2=2^(it-1);
	
   tic
   for x1=-m:fac1:m
      for x2=-m:fac1:m
	 i=(x1+m)/fac1+1;
	 j=(x2+m)/fac1+1;
	 if (floor((i+1)/2) == (i+1)/2 & floor((j+1)/2) == (j+1)/2)
	    B2(i,j)=B1((i+1)/2,(j+1)/2);
	    check1=check1+1;
	 else
	    S1=0;
	    for k1=-n:n
	       for k2=-n:n
		  S2=0;
		  for r1=-n+k1-k2:n+k1-k2
		     for r2=-n+k1+k2:n+k1+k2
			if( (-2*x2-r1) >= -m & (-2*x2-r1)  <= m & (2*x1-r2) >= -m & (2*x1-r2) <= m )
			  S2=S2+A(r1-(k1-k2)+s,r2-(k1+k2)+s)*B1((-2*x2-r1+m)*fac2+1,(2*x1-r2+m)*fac2+1);
			end	%if		
		     end
		  end
		  S1=S1+S2*A(k1+s,k2+s);
	       end
	    end
	    B2(i,j)=S1;
	    check2=check2+1;
		
         end
	  
      end
   end
  
   t=toc;
   size(B2);
   B2;
   hh=findobj('Tag','VillMachPic');
   if isempty(hh)
     figure; 
     set(gcf,'Tag','VillMachPic');
   end

   hh=findobj('Tag','VillMachPic');
   figure(hh);
   surf(B2);
   
   title(['Scaling function, iteration number ',int2str(it)]) 
   
   if ~((it==iteration)&(it==1))  %no EPS file for it=iteration=1
     name=strcat(fileName,'_',int2str(it));
     print(gcf, '-deps',name)
   end

   b_it=size(B1,1);
 
   if (it==1)
     it_comment(1)={sprintf('Time needed for iteration number %1.0f: ',it)};
     it_comment(2)={sprintf('%6.6f minutes.' ,t/60)};
     it_comment(3)={'   '};
     dim_1=b_it;
     b_1=dim_1;
     it_max=5;
     it_matrix=zeros(it_max-1,2);
     for it_1=2:it_max
        it_matrix(it_1-1,1)=it_1;
        b_1=2*b_1;
        it_matrix(it_1-1,2)=(b_1^2/dim_1^2)*(t/60);
     end
     str_matrix=num2str(it_matrix);
     it_comment(4)={'The computations of the following iterations will take about:'};
     it_comment(5)={'iteration number:    time (in minutes):'};
     it_comment(6)={str_matrix};
     if (it==iteration)
       it_comment(7)={'   '};
       it_comment(8)={'Plotting done.'};
     end
     text_out(it_comment);
   end
   clear it_matrix

    
     if (it>=2)&(it==iteration)
       time_it=(2*b_it)^2/(b_it^2)*(t/60);  
       it_comment(7)={'    '};   
       it_comment(8)={sprintf('Time needed for iteration number %1.0f: ',it)};
       it_comment(9)={sprintf('%6.6f minutes.' ,t/60)};
       it_comment(10)={'   '};
       it_comment(11)={'Plotting done.'};
       it_comment(12)={'   '};
       it_comment(13)={'The pictures have been saved in the following EPS files: '};
       for nr=1:it
          str_nr=int2str(nr);
          it_comment(13+nr)={strcat(fileName,'_',str_nr,'.eps')};
       end
       it_comment(13+nr+1)={'in the current directory.'};
     end 
     text_out(it_comment);
    % clear t


 end %for it
		   
end %if (sum(sum(abs(M-DM1)))==0) 


  %---Visualisation of the scaling function for matrix M=[2 0 ; 0 2]

%Checking the dilation matrix:
if (sum(sum(abs(M-DM2)))==0)
  dm=det(M);

%Parameters:
n1=min(min(mask(:,1)),min(mask(:,2)));
n2=max(max(mask(:,1)),max(mask(:,2)));
s=abs(n1)+1;
N_mask=n2-n1+1;
l=length(mask(:,1));

%Checking for normalization:
if sum(mask(:,3)) ~= 1 
	dm=1;
end

%Mask of coefficients:
A=zeros(N_mask);
for i=1:l
        A(mask(i,1)+s,mask(i,2)+s) = mask(i,3)*dm;
end
A;

clear mask;


%Defining phi_0:

%If the scaling function is interpolating then one has to use:
if (interpol_num==1)
  c=ceil(N_mask/2); 
  dim=N_mask;
  B2=zeros(dim);
  B2(c,c)=1;
  size(B2);
  B2;
end


%If the scaling function is not interpolating then one has to use the largest eigenvalue:
if (interpol_num==0)
  load 'EV.mat'
  length(big_ev);
  dim=sqrt(length(big_ev));
  B2=zeros(dim);
  for i=1:dim
    for j=1:dim
	B2(i,j)=big_ev(j+(i-1)*dim);
    end
  end
  size(B2); 
  B2;
end

clear big _ev;

%Calculation 

for it=1:iteration
   T_T={sprintf('Computing iteration number %1.0f of the visual program...',it)};  
   text_out(T_T);
   B1=B2;
   clear B2; 
   fac1=2^(-it);
   fac2=2^(it-1);
   b=(n2-n1)/fac1+1;
   B2=zeros(b);
 
   tic
   for x1=1:b
     for x2=1:b
       for k1=n1:n2
	 for k2=n1:n2
           if((x1-(k1+s-1)*fac2)>=1 & (x1-(k1+s-1)*fac2)<=dim & (x2-(k2+s-1)*fac2)>=1 & (x2-(k2+s-1)*fac2)<=dim)
             B2(x1,x2)=B2(x1,x2)+A(k1+s,k2+s)*B1(x1-(k1+s-1)*fac2,x2-(k2+s-1)*fac2);
           end 
	 end
       end
     end
   end
   t=toc;
   size(B2);
   B2;

   hh=findobj('Tag','VillMachPic');
   if isempty(hh)
     figure; 
     set(gcf,'Tag','VillMachPic');
   end
   hh=findobj('Tag','VillMachPic');
figure(hh);
   surf(B2);

   title(['Scaling function, iteration number ',int2str(it)])

   if (it==1)
     it_comment(1)={sprintf('Time needed for iteration number %1.0f: ',it)};
     it_comment(2)={sprintf('%6.6f minutes.' ,t/60)};
     it_comment(3)={'    '};
     dim_1=b;
     it_max=5;
     it_matrix=zeros(it_max-1,2);
     for it_1=2:it_max
       it_matrix(it_1-1,1)=it_1;
       fac1_1=2^(-it_1);
       fac2_1=2^(it_1-1);
       b_1=(n2-n1)/fac1_1+1;
       it_matrix(it_1-1,2)=(b_1^2/dim_1^2)*(t/60);
     end
     str_matrix=num2str(it_matrix);
     it_comment(4)={'The computations of the following iterations will take about:'};
     it_comment(5)={'iteration number:    time (in minutes):'};
     it_comment(6)={str_matrix};
     if (it==iteration)
       it_comment(7)={'   '};
       it_comment(8)={'Plotting done.'};
     end
     text_out(it_comment);
   end
   clear it_matrix

   if (it>=2)&(it==iteration)
     time_it=(b^2/dim^2)*(t/60);
     it_comment(7)={'   '};
     it_comment(8)={sprintf('Time needed for iteration number %1.0f: ',it)};
     it_comment(9)={sprintf('%6.6f minutes.' ,t/60)};
     it_comment(10)={'   '};
     it_comment(11)={'Plotting done.'};
     it_comment(12)={'    '}; 
     it_comment(13)={'The computation of the next iteration would take about:'};
     it_comment(14)={sprintf('%6.3f minutes.',time_it)};
     text_out(it_comment);
   end
   clear t

   dim=b;

 end % for it

 end %if (sum(sum(...))==0)
end %if (isempty(big_ev))


%----------------------
function text_out(out_text,out_color, out_value);
%----------------------

if (nargin<=2) out_value=1; end;
if (nargin<=1) out_color=[0 0 0.5]; end;
if (nargin==0) out_text=''; end;

hhh=findobj('Tag','VILLMACH1');

hh=findobj(hhh,'Tag','TextBox');
set(hh,'ForegroundColor',out_color);
set(hh,'String', out_text);
set(hh,'Value',out_value);
