%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Filename:     gui_plot.m
% Written by:   Markus Hampel
% Version:      1.0, 2003
%
% Description:
% Plots a scaling vector (Dimension d=1)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function varargout = gui_plot(varargin)
% GUI_PLOT Application M-file for gui_plot.fig
%    FIG = GUI_PLOT launch gui_plot GUI.
%    GUI_PLOT('callback_name', ...) invoke the named callback.


if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));

    % Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

    %============================================================
    % setting some defaults
    %global m_mask;
    %set(handles.edit_L, 'String', min(m_mask(:, 1)));
    %set(handles.edit_R, 'String', max(m_mask(:, 1)));
    set(handles.edit_numIter, 'String', '4');
    set(handles.edit_offset, 'String', '0');
    %============================================================
    
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end


%--------------------------------------------------------------------------
% Button:       Plot
% Beschreibung: Plottet den Generator als "r" einzelne Funktionen,
%               ruft Hilfsfunktion VisMult(...) auf
%--------------------------------------------------------------------------

function varargout = button_plot_Callback(h, eventdata, handles, varargin)

global m_mask;
global M_M;
global lastFigure;

M = M_M;

% Maskenformat konvertieren
[A, versch_L, versch_L2] = m_mask2A(m_mask);

% eingegebene Werte auslesen und parsen
nIter  = str2num(get(handles.edit_numIter, 'String'));
offset = str2num(get(handles.edit_offset, 'String')) - versch_L;

% Falls noch kein Output-Fenster vorhanden ist, erstelle eins!
if isempty(lastFigure)
    lastFigure = figure;
end
% Falls ein neues Output-Fenster erwuenscht ist, erstelle eins!
if (get(handles.checkbox_newFigure, 'Value') == get(handles.checkbox_newFigure, 'Max'))
    lastFigure = figure;
else % in letztes, vorhandenes Fenster zeichnen
    figure(lastFigure);
end

% Zeichen-Routine aufrufen
%VisMult(mask, L, R, LL, RR, it, offset);
tic
[Phi, errormsg] = plotScalingvector(A, M, nIter, 0, 0, 0, offset);
toc

% Auswahl-GUI loeschen
delete(handles.figure_plot);

% Skalierungsvektor zeichnen
if strcmp(errormsg, '') ~= 1
    disp(errormsg)
else
    plot(Phi(1, :), Phi(2, :));
end