%callback file for the mask generator

%written by A. Barinka, january 2000.
%IGPM, RWTH-Aachen, GERMANY


%------------------------------------------------------------------
function masked(defa)
%------------------------------------------------------------------

%--------set all these global variables----------------------------
%startup/initialization data
global homedir;
global datadir;
global p_position;
global PSviewer;

%results from doOne/doTwo->need for warnings
global r_regular;
global index_A_A;
global no_ev;
global spec_rad;
global EW_M;
global interpol_str;


%data from data files
global m_mask_comment;
global m_mask;

%for savety read villmach_init again
villmach_init;


%--------set up directory stearing variable------------------------
%--------cut the blank off the beginning of datadir ---------------
s_s=size(datadir);
datadir1=datadir(1,2:s_s(2));
nowdir=datadir;
nowdir1=datadir1;


%----Test to check if figure exists allready---
callingObject='initialize';
do=get(gcbf,'Tag');
s_s=size(do);
if (s_s(2)>=10)
   do=do(1:10);
   if strcmp(do,'maskeditor'),
      callingObject=get(gcbo,'Tag');
   end;
end


%------------------------------------------------------------------
%+++++Here are the callbacks for the elements of the figure++++++++

switch callingObject
%------------------------------------------------------------------

%----------------
case 'initialize'
%----------------
   %----Open the figure, fine tune  and use this callback function's name 
   % as an identifier for the figure-------
 
   masked_gui;
   p_pos=get(gcf,'position');
   p_pos(1)=p_position(1);
   p_pos(2)=p_position(2)-80 ;
   set(gcf, 'position', p_pos);

   set(gcf,'NumberTitle','off');
   set(gcf,'Name','Villemoes Machine: Mask editor');
   set(gcf,'MenuBar','none');
  
   if strcmp(get(gcf,'Tag'),'medit') set(gcf,'Tag','maskeditor'); end;

    %----setup input stuff----------------
    
    h_h=findobj(gcf,'Tag','Push1');
    set(h_h,'ForegroundColor','black');
    h_h=findobj(gcf,'Tag','Push2');
    set(h_h,'ForegroundColor','blue');

    h_h=findobj(gcf,'Tag','mode');
    T_T={'Edit mode: Borders and mask matrix.', 'Edit mode: Lattice points and mask coefficients.'}; 
    set(h_h,'string',T_T);
    set(h_h,'value',1);
    
    h_h=findobj(gcf,'Tag','a2Box');
    set(h_h,'Visible','on');
    h_h=findobj(gcf,'Tag','a2Ed');
    set(h_h,'Visible','on');

    h_h=findobj(gcf,'Tag','b2Box');
    set(h_h,'Visible','on');
    h_h=findobj(gcf,'Tag','b2Ed');
    set(h_h,'Visible','on');
   
   %---now set up the textbox--------------
   standard_out_gen;

   %---1d or 2d---------------

   if (nargin~=1) defa=2; end;
   if (defa==1)
     h_h=findobj(gcf,'Tag','Push2');
     set(h_h,'ForegroundColor','black');
     h_h=findobj(gcf,'Tag','Push1');
     set(h_h,'ForegroundColor','blue');

     h_h=findobj(gcf,'Tag','a2Ed');
     set(h_h,'Visible','off');
   
     h_h=findobj(gcf,'Tag','a2Box');
     set(h_h,'Visible','off');

     h_h=findobj(gcf,'Tag','b2Ed');
     set(h_h,'Visible','off');

     h_h=findobj(gcf,'Tag','b2Box');
     set(h_h,'Visible','off');

     direct='oneD';

     maskitstr1='';
     maskitstr2=...
     'Enter the mask matrix in standard MATLAB format, e.g. a=[1 2 3];.';
     bordertxt='Enter the borders [a1,b1] of your mask.';
    
           
   else %defa  
      h_h=findobj(gcf,'Tag','Push1');
      set(h_h,'ForegroundColor','black');
      h_h=findobj(gcf,'Tag','Push2');
      set(h_h,'ForegroundColor','blue');

      h_h=findobj(gcf,'Tag','a2Ed');
      set(h_h,'Visible','on');
   
      h_h=findobj(gcf,'Tag','a2Box');
      set(h_h,'Visible','on');

      h_h=findobj(gcf,'Tag','b2Ed');
      set(h_h,'Visible','on');

      h_h=findobj(gcf,'Tag','b2Box');
      set(h_h,'Visible','on');

      direct='twoD';

      maskitstr1=...
     'Enter the mask matrix in standard MATLAB format, e.g. a=[11 12 13; 21 22 23];.';
      maskitstr2='(Semikoli will end rows.)';
      bordertxt='Enter the borders [a1,b1]x[a2,b2] of your mask. (x direction = columns in mask).';
      
   
   end; %defa

     h_h=findobj(gcf,'Tag','maskit1');
     set(h_h,'string',maskitstr1);
     h_h=findobj(gcf,'Tag','maskit2');
     set(h_h,'string',maskitstr2);
     h_h=findobj(gcf,'Tag','bordertext');
     set(h_h,'string',bordertxt);
      
     m_mask=[];
     setup_Filelist(gcf,nowdir1, direct);

 

%===============================================

  
%----------------
case 'FileListBox'
%---------------- 
  
   %---set default comment
   m_mask_comment={'Sorry, no comment for this mask.'};
   
   %---Handle the filelist & set current directory---------
   fileListHndl=findobj(gcf,'Tag','FileListBox');
   fileList=get(fileListHndl,'String');
   s_s=size(fileList);
   if (s_s(2)==0)
      disp('WARNING: No data found in current directory!');
   else %there is data
     fileIndex=get(fileListHndl,'Value');
     fileName=fileList{fileIndex};
     sname=size(fileName);
     if (sname(2)>2)
       h_h=findobj(gcf,'Tag','maskname');
       set(h_h,'String',fileName);
       sname=sname(2)-2;
       fileName=fileName(1:sname);

       h_h=findobj(gcf,'Tag','Push1');
       d_d=get(h_h,'ForegroundColor');
       if (d_d==[0 0 1]) %1 d 
         direct='oneD';
       else%2d
         direct='twoD';
       end;


       %---run load-file
       do=strcat('cd ', nowdir,'/',direct);
       format long g;
       wrong=0;
       eval(do,'wrong=1;');
       if wrong==1
          T_T=strcat('Cannot evaluate: <',do,'>! Check villmach_init.m!');
          text_out(T_T,[0.5 0 0],1);
          return;
       end;
       wrong=0;
       eval(fileName, 'wrong=1;');
       if wrong==1
          T_T=strcat('Cannot find file <',fileName,'>!');
          text_out(T_T,[0.5 0 0],1);
          return;
       end;

       %---setup comment
       m_mask_str=num2str(m_mask);
       m_mask_comment_ext=m_mask_comment;
       s_maskcomm=size(m_mask_comment);
       m_mask_comment_ext(s_maskcomm(2)+1)={'-------------------------'};
       if (d_d==[0 0 1])%1d
         m_mask_comment_ext(s_maskcomm(2)+2)={'Format: | index | mask coefficient |'};
       else
         m_mask_comment_ext(s_maskcomm(2)+2)={'Format: | row index |  column index |  mask coefficient  |'};
     
       end;
       m_mask_comment_ext(s_maskcomm(2)+3)={''};
       m_mask_comment_ext(s_maskcomm(2)+4)={m_mask_str};
       text_out(m_mask_comment_ext);
       
     else
       standard_out_gen;
     end; 

     do=strcat('cd ', homedir);
     eval(do);
     
  end;  %there is data

  h_h=findobj(gcf,'Tag','mode');
  mode=get(h_h,'Value');
 
if (mode==1)
  %--print out da stuff
   a1=min(m_mask(:,2));
   h_h=findobj(gcf,'Tag','a1Ed');
   set(h_h,'String',num2str(a1));

   b1=max(m_mask(:,2));
   h_h=findobj(gcf,'Tag','b1Ed');
   set(h_h,'String',num2str(b1));

  if (d_d==[0 0 1]) %1 d 
     m_str=num2str(m_mask(:,2)');
     m_str=strcat('a=[',m_str,'];');

  else %2d
     a2=min(m_mask(:,1));
     h_h=findobj(gcf,'Tag','a2Ed');
     set(h_h,'String',num2str(a2));

     b2=max(m_mask(:,1));
     h_h=findobj(gcf,'Tag','b2Ed');
     set(h_h,'String',num2str(b2));
     
     M_M=zeros(b2-a2+1, b1-a1+1);
     s_s_s=size(m_mask);
     for i=1:s_s_s(1)
         x_x=m_mask(i,1)-a2+1;
         y_y=m_mask(i,2)-a1+1;
         M_M(x_x, y_y)=m_mask(i,3);
     end;
     m_str='a=[';
     
     for i=1:b2-a2
        m_str=strcat(m_str,num2str(M_M(i,:)),';');
     end;
     m_str=char(strcat(m_str,num2str(M_M(b2-a2+1,:)),'];'));

  end;  
else%mode is different
  m_str='a=[ ';
  M_Ma=num2str(m_mask);
  s_s=size(M_Ma);
  for i=1:s_s(1)-1
     m_str=strcat(m_str,M_Ma(i,:),';');
  end;
m_str=strcat(m_str,M_Ma(s_s(1),:));
     m_str=strcat(m_str,'];');
end;


  h_h=findobj(gcf,'Tag','maskBox');
  set(h_h,'String',m_str);

  %--now get comment lines
  if (s_maskcomm>4) 
       T_T={'Warning: There are more then 4 lines of comment.' ' '};
       text_out(T_T,[0.5 0 0],1);
       pause(1);
  end;
  s_s=min(4,s_maskcomm(2));

  for i=1:s_s
     do=strcat('comm',num2str(i));
     h_h=findobj(gcf,'Tag',do);
     set(h_h,'String',char(m_mask_comment(i)));
  end;

  for i=s_s+1:4
     do=strcat('comm',num2str(i));
     h_h=findobj(gcf,'Tag',do);
     set(h_h,'String','');
  end;

%---------- 
case 'Push1'
%----------
    %---handle textbox
    standard_out;
    
    %---set graphivs for 1D
    set(gcbo,'ForegroundColor','blue');

    h_h=findobj(gcf,'Tag','Push2');
    set(h_h,'ForegroundColor','black');

    h_h=findobj(gcf,'Tag','mode');
    mode=get(h_h,'value');

    if (mode==1)
      h_h=findobj(gcf,'Tag','a2Ed');
      set(h_h,'Visible','off');
   
      h_h=findobj(gcf,'Tag','a2Box');
      set(h_h,'Visible','off');

      h_h=findobj(gcf,'Tag','b2Ed');
      set(h_h,'Visible','off');

      h_h=findobj(gcf,'Tag','b2Box');
      set(h_h,'Visible','off');
      bordertxt='Enter the borders [a1,b1] of your mask. ';
      maskitstr1='';
      maskitstr2=...
      'Enter the mask in standard MATLAB format, e.g. a=[1 2 3];.';
      h_h=findobj(gcf,'Tag','bordertext');
      set(h_h,'string',bordertxt);
    else
      maskitstr1=...
        'Enter the mask in format a=[xpos1 value1; xpos2 value1];';
      maskitstr2='(Semikoli will end rows.)';
      
    end;

    h_h=findobj(gcf,'Tag','maskit1');
    set(h_h,'string',maskitstr1);
    h_h=findobj(gcf,'Tag','maskit2');
    set(h_h,'string',maskitstr2);
    
    direct='oneD';
    reset_it(2);

    m_mask=[];
    setup_Filelist(gcf,nowdir1,direct);
   
    
%---------- 
case 'Push2'
%----------
    %---handle textbox-------------------
    standard_out;

    %---handle graphics for 2D
    set(gcbo,'ForegroundColor','blue');

    h_h=findobj(gcf,'Tag','Push1');
    set(h_h,'ForegroundColor','black');

    h_h=findobj(gcf,'Tag','mode');
    mode=get(h_h,'value');

    if (mode==1)
      h_h=findobj(gcf,'Tag','a2Ed');
      set(h_h,'Visible','on');
   
      h_h=findobj(gcf,'Tag','a2Box');
      set(h_h,'Visible','on');

      h_h=findobj(gcf,'Tag','b2Ed');
      set(h_h,'Visible','on');

      h_h=findobj(gcf,'Tag','b2Box');
      set(h_h,'Visible','on');
    maskitstr1=...
'Enter the mask in standard MATLAB format, e.g. a=[11 12 13; 21 22 23];.';
    maskitstr2='(Semikoli will end rows.)';
    
 
    bordertxt='Enter the borders [a1,b1]x[a2,b2] of your mask. (x direction = columns in mask).';
    h_h=findobj(gcf,'Tag','bordertext');
    set(h_h,'string',bordertxt);
    
    else 
        maskitstr1=...
    'Enter the mask in format a=[xpos1 ypos1 value1; xpos2 ypos2 value1];';
          maskitstr2='(Semikoli will end rows.)'; 
    end;
  
    h_h=findobj(gcf,'Tag','maskit1');
    set(h_h,'string',maskitstr1);
    h_h=findobj(gcf,'Tag','maskit2');
    set(h_h,'string',maskitstr2);
    direct='twoD';
  
    reset_it(2);
    m_mask=[];
    setup_Filelist(gcf,nowdir1,direct);
   

%----------
case 'mode'
%----------
    mode=get(gcbo,'value');
    h_h=findobj(gcf,'Tag','Push1');
    d_d=get(h_h,'ForegroundColor');

    if (mode==1)
      visib='on';
      if (d_d==[0 0 1]) %1 d 
        bordertxt='Enter the borders [a1,b1] of your mask. ';
        maskitstr1='';
        maskitstr2=...
        'Enter the mask in standard MATLAB format, e.g. a=[1 2 3];.';
      else%2d
          maskitstr1=...
    'Enter the mask in standard MATLAB format, e.g. a=[11 12 13; 21 22 23];.';
          maskitstr2='(Semikoli will end rows.)';
          bordertxt='Enter the borders [a1,b1]x[a2,b2] of your mask. (x direction = columns in mask).';
      end;
    else 
      visib='off';
      bordertxt='';
     if (d_d==[0 0 1]) %1 d
           maskitstr1=...
    'Enter the mask in format a=[xpos1 value1; xpos2 value1];';
          maskitstr2='(Semikoli will end rows.)';
     else
       maskitstr1=...
    'Enter the mask in format a=[xpos1 ypos1 value1; xpos2 ypos2 value1];';
          maskitstr2='(Semikoli will end rows.)';
     end;
    end;

      h_h=findobj(gcf,'Tag','a1Ed');
      set(h_h,'Visible',visib);
      set(h_h,'string','');  
      h_h=findobj(gcf,'Tag','a2Ed');
      set(h_h,'Visible',visib);  
      set(h_h,'string','');
      h_h=findobj(gcf,'Tag','b1Ed');
      set(h_h,'Visible',visib);
      set(h_h,'string','');
      h_h=findobj(gcf,'Tag','b2Ed');
      set(h_h,'Visible',visib);  
      set(h_h,'string','');

      h_h=findobj(gcf,'Tag','a1Box');
      set(h_h,'Visible',visib);      
      h_h=findobj(gcf,'Tag','a2Box');
      set(h_h,'Visible',visib);  
      h_h=findobj(gcf,'Tag','b1Box');
      set(h_h,'Visible',visib);  
      h_h=findobj(gcf,'Tag','b2Box');
      set(h_h,'Visible',visib);  

     h_h=findobj(gcf,'Tag','maskit1');
     set(h_h,'string',maskitstr1);
     h_h=findobj(gcf,'Tag','maskit2');
     set(h_h,'string',maskitstr2);
     h_h=findobj(gcf,'Tag','bordertext');
     set(h_h,'string',bordertxt);


     h_h=findobj(gcf,'Tag','comm1');
     set(h_h,'string','');
     h_h=findobj(gcf,'Tag','comm2');
     set(h_h,'string','');
     h_h=findobj(gcf,'Tag','comm3');
     set(h_h,'string','');
     h_h=findobj(gcf,'Tag','comm4');
     set(h_h,'string','');

     h_h=findobj(gcf,'Tag','FileListBox');
     help=get(h_h,'String');
     s_help=size(help);
     set(h_h,'Value',s_help(1));

     standard_out_gen;


     h_h=findobj(gcf,'Tag','maskBox');
     set(h_h,'string','a=[ ];');

     h_h=findobj(gcf,'Tag','maskname');
     set(h_h,'string','default.m');

     %---check wether 1d or 2d file
     h_h=findobj(gcf,'Tag','Push1');
     d_d=get(h_h,'ForegroundColor');

     if (d_d==[0 0 1]) %1d 
       direct='oneD';
     else              %2d
        direct='twoD';
     end;
     setup_Filelist(gcf,nowdir1,direct);
     

%----------
case 'reset'
%----------
     reset_it(1);

%---------- 
case 'SaveBox'
%----------
  %---get filename
  h_h=findobj(gcf,'Tag','maskname');
  file_name=get(h_h,'string');
  if isempty(file_name) 
     T_T=('Plase enter a filename!');
     text_out(T_T,[0.5 0 0],1);
     return;
  end;
   
  %---does it end on .m?
  s_s=size(file_name);
  if (s_s<2) 
     file_name=strcat(file_name,'.m');
  else 
     s_str=file_name(s_s(2)-1:s_s(2));
     if (~strcmp(s_str,'.m')) file_name=strcat(file_name,'.m');end;
  end;  

  %---what is the mode?
  h_h=findobj(gcf,'Tag','mode');
  mode=get(h_h,'value');
  
  %---check wether 1d or 2d file
  h_h=findobj(gcf,'Tag','Push1');
  d_d=get(h_h,'ForegroundColor');

  if (d_d==[0 0 1]) %1d 
      direct='oneD';
    else              %2d
      direct='twoD';
  end;

  %---read mask
  h_h=findobj(gcf,'Tag','maskBox');
  maski=get(h_h,'string');
  wrong=0;
  eval(maski,'wrong=1');
  if (wrong==1)    
    T_T='Something is wrong with the MATLAB format of the mask you entered!';
    text_out(T_T,[0.5 0 0],1);    
    return;
  end;   
    m=a;
  s_s=size(m);

  if (mode==1)%border and stuff
    %---get border 1d
    h_h=findobj(gcf,'Tag','a1Ed');
    a1=str2num(get(h_h,'string'));
    h_h=findobj(gcf,'Tag','b1Ed');
    b1=str2num(get(h_h,'string'));
    s_sx=b1-a1+1;  

    if strcmp(direct,'twoD');
      %now we have to get 2d borders too
      h_h=findobj(gcf,'Tag','a2Ed');
      a2=str2num(get(h_h,'string'));
      h_h=findobj(gcf,'Tag','b2Ed');
      b2=str2num(get(h_h,'string'));
      s_sy=b2-a2+1;
    end;
         
    %--- check if mask fits area [a1,b1]x[a2,b2]---
    %x dimension in both cases 1 and 2 D:
    if (s_s(2)~=s_sx) 
      T_T='x dimension of your mask does not fit your area [a1,b1]!';
      text_out(T_T,[0.5 0 0],1);
      return; 
    end;    

    if (d_d==[0 0 1])%1D: y dimen =1
      if (s_s(1)~=1)
        T_T=('Please enter a one dimensional mask! ');
        text_out(T_T,[0.5 0 0],1);
        return; 
      end;
    else %2d: y dimen=s_sy
      if (s_s(1)~=s_sy)  
        T_T='y dimension of your mask does not fit your area [a2,b2]!';
        text_out(T_T,[0.5 0 0],1);
        return; 
       end;
    end;   
 
  else
    %check dimension
    if (d_d==[0 0 1])%1D: y dimen =1
      if (s_s(2)~=2)
        T_T=('Please enter a one dimensional mask! ');
        text_out(T_T,[0.5 0 0],1);
        return; 
      end;
      else %2d: y dimen=s_sy
      if (s_s(2)~=3)  
        T_T=('Please enter a two dimensional mask! ');
        text_out(T_T,[0.5 0 0],1);
        return; 
       end;
     end;   

    end;
  
    
  %---check comment lines
  h_h=findobj(gcf,'Tag','comm1');
  comm1=get(h_h,'string');
  %if isempty(comm1) comm1='Sorry, no comment for this mask.'; end;
  h_h=findobj(gcf,'Tag','comm2');
  comm2=get(h_h,'string');
  h_h=findobj(gcf,'Tag','comm3');
  comm3=get(h_h,'string');
  h_h=findobj(gcf,'Tag','comm4');
  comm4=get(h_h,'string');

do=strcat('m_mask_comment={',' ''',comm1,' '' ',' '' ',comm2,' '' ',' '' ',comm3,' '' ',' '' ',comm4,' '' };');
  wrong=0;
  eval(do,'wrong=1');
  if (wrong==1)
     T_T={'Something is wrong with your comment lines' 'Most probably you used single quote characters, please use double quotes instead!'};
    text_out(T_T,[0.5 0 0],1);
    return;
     end;

  %---finally start writing
    file_name=strcat(nowdir1,'/',direct,'/',file_name);
  fid=fopen(file_name,'w');
  if (fid<0) 
     T_T=strcat('Sorry, cannot write file <',file_name,'>.');
     text_out(T_T,[0.5 0 0],1);
     return;
  end;

  fprintf(fid,'%s\n','global m_mask;');
  fprintf(fid,'%s\n','global m_mask_comment');
  
  %---write comment-lines
  fprintf(fid,'%s\n','m_mask_comment={...');
  fprintf(fid,'%s','''');
  fprintf(fid,'%s',comm1);
  fprintf(fid,'%s\n',''' ...');
  if ~strcmp(comm2,'');
     fprintf(fid,'%s','''');
     fprintf(fid,'%s',comm2);
     fprintf(fid,'%s\n',''' ...');
  end;
  if ~strcmp(comm3,'');
     fprintf(fid,'%s','''');
     fprintf(fid,'%s',comm3);
     fprintf(fid,'%s\n',''' ...');
  end;
  if ~strcmp(comm4,'');
     fprintf(fid,'%s','''');
     fprintf(fid,'%s',comm4);
     fprintf(fid,'%s\n','''};');
  else
     fprintf(fid,'%s\n','};');
  end;
  
 
  fprintf(fid,'%s\n','m_mask=[...');

  if (mode==1)
    %---now write the mask--> format conversion 
    if (d_d==[0 0 1]) %1 d 
      jj=0;      
      for j=a1:b1
        jj=jj+1;
        fprintf(fid,'%10.3f',j);
        fprintf(fid,'%16.10f',m(jj));
        fprintf(fid,'%s\n',';...');
      end;
    else %2d
       ii=0;
       for i=a1:1:b1
         jj=0;
         ii=ii+1;
         for j=a2:1:b2
           jj=jj+1;
           fprintf(fid,'%10.3f',j);
           fprintf(fid,'%10.3gf',i);
           fprintf(fid,'%16.10f',m(jj,ii));
           fprintf(fid,'%s\n',';...');
         end;
       end;
 
     end %1 or 2 d
  
  else%mode ==2
    for i=1:s_s(1)-1
       fprintf(fid,'%4.1f',m(i,1));
       if d_d==[0 0 1]%1D 
          fprintf(fid,'%16.10f',m(i,2));
       else
          fprintf(fid,'%4.1f',m(i,2));
          fprintf(fid,'%16.10f',m(i,3));
       end;
       fprintf(fid,'%s\n',';...');
    end;
       
       i=s_s(1); 
       fprintf(fid,'%4.1f',m(i,1));
       if d_d==[0 0 1]%1D 
          fprintf(fid,'%16.10f',m(i,2));
       else
          fprintf(fid,'%4.1f',m(i,2));
          fprintf(fid,'%16.10f',m(i,3));
       end;
  end;    

  fprintf(fid,'%s','];');  
  fclose(fid);


  setup_Filelist(gcf,nowdir1,direct);

  %---refresh Filelist from calling VILLEMOES MACHINE
  VMMtag=get(gcf,'Tag');
  s_s=size(VMMtag);
  VMMtag=VMMtag(11:s_s(2));
  h_h=findobj('Tag',VMMtag);

  %check dimension there
   hh=findobj(h_h,'Tag','M21Box');
   on_str=get(hh,'Visible');
   if (d_d==[0 0 1])
         if (strcmp(on_str,'off'))
           setup_Filelist(h_h,nowdir1,direct); 
	 end;
   else
         if (strcmp(on_str,'on'))
           setup_Filelist(h_h,nowdir1,direct); 
	 end;
  end;

  %---feed back
  T_T='Mask saved.';
  text_out(T_T);
  pause(2);

  standard_out;

%-------------
case 'DelBox'
%-------------
  %get file Name
   fileListHndl=findobj(gcf,'Tag','FileListBox');
   fileList=get(fileListHndl,'String');
   s_s=size(fileList);
   if (s_s(2)==0)
     T_T={'No data found!' };
     text_out(T_T,[0.5 0 0],1);
     return;  
      
   else %there is data
     fileIndex=get(fileListHndl,'Value');
     fileName=fileList{fileIndex};
     if strcmp(fileName,'')
        T_T={'To kill a mask, you have to choose a name: Click on the mask-name in the list, then press DELETE.' };
        text_out(T_T,[0.5 0 0],1);
        return; 
      end; 
   end;
   
  %--- which directory?
  h_h=findobj(gcf,'Tag','Push1');
  d_d=get(h_h,'ForegroundColor');
  if (d_d==[0 0 1]) %1 d 
    direct='oneD';
  else
    direct='twoD';
  end;

  fileName=strcat(nowdir,'/',direct,'/',fileName);
  do=strcat('!rm ',fileName);
  wrong=0;
  eval(do,'wrong=1;');

  setup_Filelist(gcf,nowdir1,direct);

  %---refresh Filelist from calling VILLEMOES MACHINE
  VMMtag=get(gcf,'Tag');
  s_s=size(VMMtag);
  VMMtag=VMMtag(11:s_s(2));
  h_h=findobj('Tag',VMMtag);
  %check dimension there
   hh=findobj(h_h,'Tag','M21Box');
on_str=get(hh,'Visible');
   if (d_d==[0 0 1])
         if (strcmp(on_str,'off'))
           setup_Filelist(h_h,nowdir1,direct); 
	 end;
   else
         if (strcmp(on_str,'on'))
           setup_Filelist(h_h,nowdir1,direct); 
	 end;
  end;
 
  
  %---feed back
  T_T='Mask deleted.';
  text_out(T_T);
  pause(2);
  standard_out;

%-------------
case 'HelpBox'
%-------------
    go=strcat('!',PSviewer,' VMM_doku.ps&');
    eval(go);
    standard_out_gen;


%------------
case 'InfoBox'
%------------
 %set current dir
  do=strcat('cd ', nowdir);
  eval(do);
  feval('info_file');
  
  do=strcat('cd ', homedir);
  eval(do);


%----------
case 'Exit'
%----------
   close(gcf);
  

end %switch callingObject

%=============help stuff===================

%-------------------------------
function reset_it(gen);
%-------------------------------
h_h=findobj(gcf,'Tag','maskname');
set(h_h,'string','default.m');

h_h=findobj(gcf,'Tag','a1Ed');
set(h_h,'string','');
h_h=findobj(gcf,'Tag','a2Ed');
set(h_h,'string','');
h_h=findobj(gcf,'Tag','b1Ed');
set(h_h,'string','');
h_h=findobj(gcf,'Tag','b2Ed');
set(h_h,'string','');

h_h=findobj(gcf,'Tag','maskBox');
set(h_h,'string','a=[ ];');

h_h=findobj(gcf,'Tag','comm1');
set(h_h,'string','');
h_h=findobj(gcf,'Tag','comm2');
set(h_h,'string','');
h_h=findobj(gcf,'Tag','comm3');
set(h_h,'string','');
h_h=findobj(gcf,'Tag','comm4');
set(h_h,'string','');

h_h=findobj(gcf,'Tag','FileListBox');
help=get(h_h,'String');
s_help=size(help);
set(h_h,'Value',s_help(1));

if gen==1
 standard_out_gen;
else
 standard_out;
end;



%-------------------------------
function setup_Filelist(handle, nowdir1, direct)
%-------------------------------
do=strcat(nowdir1, '/default.m');
defaultStruct=dir(do);
do=strcat(nowdir1, '/',direct,'/*.m');
fileListStruct=dir(do);
fileList={defaultStruct.name, fileListStruct.name,'zzzzzzzzzzzzzz'};
s_s=size(fileList);
s_s=s_s(2);
fileListHndl=findobj(handle,'Tag','FileListBox');
if (s_s==0) 
   T_T=('WARNING: No data found in current directory!'); 
   text_out(T_T,[0.5 0 0],1);
   return;
else
   fileList=sort(fileList);
   fileList(s_s)=cell(1,1);
   set(fileListHndl,'String',fileList);
   set(fileListHndl,'Value',s_s);
end;


%----------------------
function standard_out_gen
%----------------------
T_T={...
'First choose the dimension by pressing 1D or 2D.' ... 
'The corresponding, allready existing masks will appear in the list to the upper right.' ...
'>Choose the edit mode you want to by click/hold on EDIT MODE:...' ... 
'>To modify a mask: Choose a mask from the list by clicking on it, then edit the above ' ...
' fields (click and type). When you are done,  save the mask by pressing SAVE.' ...
'>To create a new mask: Choose a name, fill out the above fields and click on SAVE.' ...
'>To kill a mask: Click on the  mask name in the list, then press DELETE.' ...
' ' ... 
'Click on HELP for more information.' };
       
hh=findobj(gcf,'Tag','TextBox');
v=[0 0 0.5];
set(hh,'ForegroundColor',v);
v=[0.7 0.7 0.7];
set(hh,'BackgroundColor',v);
set(hh,'String', T_T);
set(hh,'Value',1);


%----------------------
function standard_out
%----------------------
T_T={...
'>Choose the edit mode you want to work in by click/hold on EDIT MODE:...' ... 
'>To modify a mask: Choose a mask from the list by clicking on it, then edit the above ' ...
' fields (click and type). When you are done,  save the mask by pressing SAVE.' ...
'>To create a new mask: Choose a name, fill out the above fields and click on SAVE.' ...
'>To kill a mask: Click on the  mask name in the list, then press DELETE.' ...
' ' ... 
'Click on HELP for more information.' };
       
hh=findobj(gcf,'Tag','TextBox');
v=[0 0 0.5];
set(hh,'ForegroundColor',v);
v=[0.7 0.7 0.7];
set(hh,'BackgroundColor',v);
set(hh,'String', T_T);
set(hh,'Value',1);


%----------------------
function text_out(out_text,out_color, out_value);
%----------------------
if (nargin<=2) out_value=1; end;
if (nargin<=1) out_color=[0 0 0.5]; end;
if (nargin==0) out_text=''; end;

hh=findobj(gcf,'Tag','TextBox');
set(hh,'ForegroundColor',out_color);
v=[0.7 0.7 0.7];
set(hh,'BackgroundColor',v);
set(hh,'String', out_text);
set(hh,'Value',out_value);


%=============EOF==============================================================









