%callback file for the Villemoes machine

%written by A. Barinka, october 1999. Modified december 1999.
%IGPM, RWTH-Aachen, GERMANY


%------------------------------------------------------------------
function villmach
%------------------------------------------------------------------

%--------set all these global variables----------------------------
%startup/initialization data
global homedir;
global datadir;
global p_position;
global PSviewer;

%results from doOne/doTwo->need for warnings
global r_regular;
global index_A_A;
global no_ev;
global spec_rad;
global EW_M;
global interpol_str;
global time_str;

%variables needed for the visual program VisTwo.m
global interpol_num;
global big_ev;
global fileName;

%data from data files
global m_mask_comment;
global m_mask;

%for savety read villmach_init again
villmach_init;


%v=[0 0 0];
%h_h=findobj(gcf,'Tag','EPS');
%set(h_h,'ForegroundColor',v); 


%--------set up directory stearing variable------------------------
%--------cut the blank off the beginning of datadir ---------------
s_s=size(datadir);
datadir1=datadir(1,2:s_s(2));
nowdir=datadir;
nowdir1=datadir1;



%----Test to check if figure exists allready---
callingObject='initialize';
do=get(gcbf,'Tag');
s_s=size(do);
if (s_s(2)>=8)
   do=do(1:8);
   if strcmp(do,'VILLMACH'),
      callingObject=get(gcbo,'Tag');
   end;
end


%------------------------------------------------------------------
%+++++Here are the callbacks for the elements of the figure++++++++

switch callingObject
%------------------------------------------------------------------

%----------------
case 'initialize'
%----------------

   %----Open the figure, fine tune  and use this callback function's name 
   % as an identifier for the figure-------
 
   villmach_gui;
   p_pos=get(gcf,'position');
   p_pos(1)=p_position(1) ;
   p_pos(2)=p_position(2) ;
   set(gcf, 'position', p_pos);

   set(gcf,'NumberTitle','off');
   set(gcf,'Name','Villemoes Machine');
   set(gcf,'MenuBar','none');
  
   if strcmp(get(gcf,'Tag'),'villmach') 
      set(gcf,'Tag',strcat('VILLMACH',num2str(gcf))); 
   end;

   textwin_on;
  
   
    %----setup input stuff----------------
    
    h_h=findobj(gcf,'Tag','Push1');
    set(h_h,'ForegroundColor','black');
    h_h=findobj(gcf,'Tag','Push2');
    set(h_h,'ForegroundColor','blue');

    h_h=findobj(gcf,'Tag','M21Box');
    set(h_h,'Visible','on');

    h_h=findobj(gcf,'Tag','M12Box');
    set(h_h,'Visible','on');

    h_h=findobj(gcf,'Tag','M22Box');
    set(h_h,'Visible','on');

    h_h=findobj(gcf,'Tag','ModeBox');
    w_w={'    quiet' '    loud' '    algebra'};
    set(h_h,'String',w_w);
    set(h_h,'Value',1);
  
    %---now set up the textbox--------------
   
    standard_out_gen;
  

    %---Default is 2D!!!!!!---------------
    direct='twoD';
 
    setup_Filelist(nowdir1,direct);
 

%===============================================

  
%----------------
case 'FileListBox'
%---------------- 
    global fileName;

 
  %---handle textbox-------------------
   text_out(' ');
   textwin_on;
   m_mask_comment={'Sorry, no comment for this mask.' ' '};
   
   %---Handle the filelist & set current directory---------
   fileListHndl=findobj(gcf,'Tag','FileListBox');
   fileList=get(fileListHndl,'String');
   s_s=size(fileList);
   if (s_s(2)==0)
      disp('WARNING: No data found in current directory!');
   else %there is data
     fileIndex=get(fileListHndl,'Value');
     fileName=fileList{fileIndex};
     sname=size(fileName);
     if (sname(2)>2)
       sname=sname(2)-2;
       fileName=fileName(1:sname);
       h_h=findobj(gcf,'Tag','M21Box');
       on_str=get(h_h,'Visible');

       if (strcmp(on_str,'on'))
         %it is 2d
         direct='twoD';
       else
         %it is 1D
         direct='oneD';
       end;

       %run load-file
       do=strcat('cd ', nowdir,'/',direct);
       wrong=0;
       eval(do,'wrong=1;');
       if (wrong==1) 
         T_T=strcat('Sorry Cannot do <',do,'>. Check villmach_init.m if Data file is correct!');
         text_out(T_T,[0.5 0 0]);
         pause(3);
       end;
       wrong=0;
       eval(fileName,'wrong=1;');%Hier checken
        if (wrong==1) 
         T_T=strcat('Sorry. something is wrong with <',fileName,'>.') ;
         T_T={T_T,'Maybe wrong MATLAB code or file cannot found.' ...
             'Check villmach_init.m if <datadir> is correct!'};
         text_out(T_T,[0.5 0 0]);
         pause(3);
         standard_out;
       end;

       m_mask_str=num2str(m_mask);
       s_s=size(m_mask_comment);
       m_mask_comment_ext=m_mask_comment;
       m_mask_comment_ext(s_s(2)+1)={'-------------------------'};
       if (strcmp(on_str,'off'))%1d
          m_mask_comment_ext(s_s(2)+2)={'Format: | index | mask coefficient |'};
       else
          m_mask_comment_ext(s_s(2)+2)={'Format: | row index |  column index |  mask coefficient  |'};
       end;
       m_mask_comment_ext(s_s(2)+3)={''};
       m_mask_comment_ext(s_s(2)+4)={m_mask_str};
       
       hh=findobj(gcf,'Tag','TextBox');
       set(hh,'String',m_mask_comment_ext);
     else
      standard_out;
     end; 

     do=strcat('cd ', homedir);
     wrong=0;
     eval(do,'wrong=1;');
     if (wrong==1) 
       T_T=strcat('Sorry Cannot do <',do,'>. Check villmach_init.m if <homedir>  is correct!');
         text_out(T_T,[0.5 0 0]);
       end;
     
  end;  %there is data

  setup_Filelist(nowdir1, direct);
  set(fileListHndl,'Value',fileIndex);
%---------- 
case 'Push1'
%----------
    %---handle textbox-----------------------
    textwin_on;    
    standard_out;   
    
    %---handle graphics for 1D
    set(gco,'ForegroundColor','blue');
    h_h=findobj(gcf,'Tag','Push2');
    set(h_h,'ForegroundColor','black');

    h_h=findobj(gcf,'Tag','M21Box');
    set(h_h,'Visible','off');

    h_h=findobj(gcf,'Tag','M12Box');
    set(h_h,'Visible','off');

    h_h=findobj(gcf,'Tag','M22Box');
    set(h_h,'Visible','off');

    direct='oneD';

    m_mask=[];

    setup_Filelist(nowdir1,direct);
  


%---------- 
case 'Push2'
%----------
    %---handle textbox-------------------
    textwin_on;
    standard_out;   

    %---handle graphics for 2D
    set(gco,'ForegroundColor','blue');
    h_h=findobj(gcf,'Tag','Push1');
    set(h_h,'ForegroundColor','black');

    h_h=findobj(gcf,'Tag','M21Box');
    set(h_h,'Visible','on');

    h_h=findobj(gcf,'Tag','M12Box');
    set(h_h,'Visible','on');

    h_h=findobj(gcf,'Tag','M22Box');
    set(h_h,'Visible','on');

    direct='twoD';
    m_mask=[];
    
    setup_Filelist(nowdir1,direct);

  
%---------- 
case 'Go'
%----------
    textwin_on;

    if (isempty(m_mask))
      T_T={'First choose a mask from the list!' ' '}; 
      text_out(T_T,[0.5 0 0],1);    

    else %there is a mask
      h_h=findobj(gcf,'Tag','N1Box');
      v_v=get(h_h,'String');
      if (strcmp(v_v,'')) v_v='0'; end;
      v_v=str2num(v_v);
      N_N1=v_v;
      h_h=findobj(gcf,'Tag','N2Box');
      v_v=get(h_h,'String');
      if (strcmp(v_v,'')) v_v='0'; end;
      v_v=str2num(v_v);
      N_N2=v_v;

      h_h=findobj(gcf,'Tag','rBox');
      v_v=get(h_h,'String');
      if (strcmp(v_v,'')) v_v='0'; end;
      v_v=str2num(v_v);
      r_r=v_v;

      h_h=findobj(gcf,'Tag','ModeBox');
      s_mode=get(h_h,'Value');
      s_mode=s_mode-1;
   
      h_h=findobj(gcf,'Tag','M21Box');
      on_str=get(h_h,'Visible');
      
      if (strcmp(on_str,'on'))
      %it is 2d
         s_s=size(m_mask);
         if (s_s(2)~=3) 
            T_T={'Please choose a 2D mask!' ' '};
            text_out(T_T,[0.5 0 0]);
         else %everything ok 
            T_T={'Computing... ' ' '};
            text_out(T_T);
            pause(0.1);
            M_M=zeros(2,2);

            h_h=findobj(gcf,'Tag','M11Box');
            v_v=get(h_h,'String');
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(1,1)=v_v;
 
            h_h=findobj(gcf,'Tag','M21Box');
            v_v=get(h_h,'String');
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(1,2)=v_v;
  
            h_h=findobj(gcf,'Tag','M12Box');
            v_v=get(h_h,'String');
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(2,1)=v_v;
       
            h_h=findobj(gcf,'Tag','M22Box');
            v_v=get(h_h,'String'); 
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(2,2)=v_v;
  
            %assemble callstring
            do=strcat('doTwo(m_mask, N_N1, N_N2,  M_M, r_r, s_mode)');
            wrong=0;
            eval(do,'wrong=1;');
            if (wrong==1) 
         T_T=strcat('Sorry, something wrong with doTwo, check if file exists!');
         text_out(T_T,[0.5 0 0]);
       end;
          
            
            result_out(index_A_A,no_ev,spec_rad,EW_M,r_regular,interpol_str,time_str);

         end %ok 2d
      %---end 2d-------------------------------------

      else
      %it is 1D 
         s_s=size(m_mask);
         if (s_s(2)~=2) 
            T_T={'Please choose a 1D mask!' ' '};
            text_out(T_T,[0.5 0 0]);
         else
           T_T={'Computing... ' ' '};
           text_out(T_T);
           pause(0.1);

           h_h=findobj(gcf,'Tag','M11Box');
           v_v=get(h_h,'String');
           if (strcmp(v_v,'')) v_v='0'; end;
           v_v=str2num(v_v);
           clear M_M;
           M_M=v_v;

           do=strcat('doOne(m_mask, N_N1, N_N2, M_M, r_r,s_mode)'); 
           wrong=0;
           eval(do,'wrong=1;');
           if (wrong==1) 
              T_T=strcat('Sorry, cannot call doOne. Check if file exists!');
              text_out(T_T,[0.5 0 0]);
       end;
          
result_out(index_A_A,no_ev,spec_rad,EW_M,r_regular,interpol_str,time_str);

         end;%ok 1d
      end %1d
   end; %there is a mask




%----------
case 'Plot'
%----------

    textwin_on;

    if (isempty(m_mask))
      T_T={'First choose a mask from the list!' ' '}; 
      text_out(T_T,[0.5 0 0],1);    

    else %there is a mask
     
      h_h=findobj(gcf,'Tag','M21Box');
      on_str=get(h_h,'Visible');
      
      if (strcmp(on_str,'on'))
      %it is 2d
         s_s=size(m_mask);
         if (s_s(2)~=3) 
            T_T={'Please choose a 2D mask!' ' '};
            text_out(T_T,[0.5 0 0]);
         else %everything ok 
           % T_T={'Computing... ' ' '};
           % text_out(T_T);
            pause(0.1);
            M_M=zeros(2,2);

            h_h=findobj(gcf,'Tag','M11Box');
            v_v=get(h_h,'String');
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(1,1)=v_v;
 
            h_h=findobj(gcf,'Tag','M21Box');
            v_v=get(h_h,'String');
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(1,2)=v_v;
  
            h_h=findobj(gcf,'Tag','M12Box');
            v_v=get(h_h,'String');
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(2,1)=v_v;
       
            h_h=findobj(gcf,'Tag','M22Box');
            v_v=get(h_h,'String'); 
            if (strcmp(v_v,'')) v_v='0'; end;
            v_v=str2num(v_v);
            M_M(2,2)=v_v;
  
    h_h=findobj(gcf,'Tag','iternum');
    v_v=get(h_h,'String'); 
    iteration=str2num(v_v);

            %assemble callstring
            it=0;
            do=strcat('VisTwo(m_mask, M_M, iteration)');
            wrong=0;
            eval(do,'wrong=1;');
            if (wrong==1) 
         T_T=strcat('Sorry, something is wrong with VisTwo, check if file exists!');
         text_out(T_T,[0.5 0 0]);
       end;
          
            
        

         end; %ok 2d
         
     end;
 end;
         
%----------
case 'Plot_scalingVector'
%----------

    textwin_on;

    if (isempty(m_mask))
        T_T={'First choose a mask from the list!' ' '}; 
        text_out(T_T,[0.5 0 0],1);    
        
    else %there is a mask
        % Checken, ob 1D- oder 2D-Fall vorliegt
        h_h=findobj(gcf,'Tag','M21Box');
        on_str=get(h_h,'Visible');
      
        if (strcmp(on_str,'on')) %it is 2d
            global M_M;
            s_s=size(m_mask); % m_mask ist die eingelesene Maske
            % Spalten m_mask: 1: i; 2: j; 3: mask(i,j)
            if (s_s(2)~=3) % --> nur ein Index --> 1d
                T_T={'Please choose a 2D mask!' ' '};
                text_out(T_T,[0.5 0 0]);
            else %everything ok 
                pause(0.1); % ntig?? Hlt das System fr 0.1 sec an
                % Dilatationsmatrix einlesen
                M_M=zeros(2,2);

                h_h=findobj(gcf,'Tag','M11Box');
                v_v=get(h_h,'String');
                if (strcmp(v_v,'')) v_v='0'; end;
                v_v=str2num(v_v);
                M_M(1,1)=v_v;
 
                h_h=findobj(gcf,'Tag','M21Box');
                v_v=get(h_h,'String');
                if (strcmp(v_v,'')) v_v='0'; end;
                v_v=str2num(v_v);
                M_M(1,2)=v_v;
  
                h_h=findobj(gcf,'Tag','M12Box');
                v_v=get(h_h,'String');
                if (strcmp(v_v,'')) v_v='0'; end;
                v_v=str2num(v_v);
                M_M(2,1)=v_v;
       
                h_h=findobj(gcf,'Tag','M22Box');
                v_v=get(h_h,'String'); 
                if (strcmp(v_v,'')) v_v='0'; end;
                v_v=str2num(v_v);
                M_M(2,2)=v_v;
                
                gui_plot2d
            end
        %---end 2d-------------------------------------
        else %it is 1D 
            global M_M;
            s_s=size(m_mask); % m_mask ist die eingelesene Maske
            % Spalten m_mask: 1: i; 2: j; 3: mask(i,j)
            if (s_s(2)~=2) % --> zwei Indices + Wert --> 2d
                T_T={'Please choose a 1D mask!' ' '};
                text_out(T_T,[0.5 0 0]);
            else %everything ok 
                pause(0.1); % ntig?? Hlt das System fr 0.1 sec an
                % Dilatationsmatrix einlesen
                
                h_h=findobj(gcf,'Tag','M11Box');
                v_v=get(h_h,'String');
                if (strcmp(v_v,'')) v_v='0'; end;
                v_v=str2num(v_v);
                M_M=v_v;
                
                gui_plot
            end      
        end %1d
    end; %there is a mask


%-------------
case 'HelpBox'
%-------------
   textwin_on;
    
   h_h=findobj(gcf,'Tag','TextBox');
   set(h_h,'Visible','on');

   h_h=findobj(gcf,'Tag','PlotWin');
   set(h_h,'Visible','off');

    %call
    go=strcat('!',PSviewer,' VMM_doku.ps&');
    wrong=0;
    eval(go,'wrong=1;');
    if (wrong==1)
       T_T={'Cannot display helpfile VMM_doku.ps!' ...
            'Probably the POSTCRIPT viewer, you specified in the' ...
            'villmach_init.m file has a problem.'};
       text_out(T_T,[0.5 0 0]);
       pause(2);
    end;

    T_T={'Help on the Villemoes Machine' ' ' ...
    'The Villemoes Machine is to estimate a lower bound for the '...
    'Hoelder regularity of refinable functions using the Villemoes trick.'...
    'See >L. Villemoes, Wavelet analysis of refinement equations,'...
    'SIAM J. Math. Anal. 25 (1994). 1433-1460.<' ' '... 
    'The machine works as follows:' ...
    '*First choose if you want to work in one or two dimensions by'...
    ' pressing the button <1D> or <2D> respectively. Default is 2D.' ...
    ' Notice, that in the listbox <Current mask> then shows correspon-'...
    ' ding masks. In this listbox, you can choose the mask, defining the' ...
    ' refinable function by clicking on it.'...
    ' For the way, these masks are organized see the READ_ME file.' ...
    '*Next, enter the parameters N1, N2 and the Strang-Fix order.'...
    '*Now enter the dilation matrix M. By default, empty fields have the '...
    ' value 0.'...
    '*At last, hit the <Go!> button and wait a second until the result is '...
    ' displayed in the information box.' ' '...
    'In the upper right corner, you can choose 3 modes for the program,'...
    'steering the output in the MATLAB shell:' ...
    'Mode=0: nothing is displayed.'...
    'Mode=1: Full output.'...
    'Mode=2: Only the eigenvectors and eigenvalues are displayed.'...
    'In any case the regularity bound is given in the infobox!' ' '... 
    'To exit the machine, press <Exit> in the lower right corner.' ' '...
    'Web: www.igpm.rwth-aachen.de'...
    '         www.mathematik.uni-marburg.de/~dahlke/ag-numerik'};
   
    text_out(T_T,[0 0 0.5],1);

%----------
case 'edit'
%----------
      h_h=findobj(gcf,'Tag','M21Box');
      on_str=get(h_h,'Visible');
      
      thisTag=get(gcf,'Tag');
      maskedTag=strcat('maskeditor',thisTag);
      h_h=findobj('Tag',maskedTag);
      if isempty(h_h)
        if (strcmp(on_str,'off'))
        %it is 1d
           masked(1);
           h_h=findobj('Tag','maskeditor');
           set(h_h,'Tag',maskedTag);
        else
           masked(2);
           h_h=findobj('Tag','maskeditor');
           set(h_h,'Tag',maskedTag);
        end;
      else
       figure(h_h);
      end;


%-------------
case 'ModeBox'
%-------------
   h_h=findobj(gcf,'Tag','TextBox');
   TT_TT=get(h_h,'string');

   mode=get(gcbo,'Value');
   hold=0;

   switch mode
   case 1
     T_T={'You selected outpoy mode QUIET: No output in MATLAB shell.'};
     hold=2;
   case 2
     T_T={'You selected outpoy mode LOUD: Full output in MATLAB shell.'};
     hold=2;
   case 3
     T_T={'You selected outpoy mode ALGEBRA: Output of eigenvectors'  ...
        'and eigenvalues in MATLAB shell.'};
     hold=3;
   end;

   text_out(T_T);
   pause(hold);
   text_out(TT_TT);

%----------
case 'EPS'
%----------
 
  h_h=findobj(gcf,'Tag','iternum');
  it=get(h_h,'String');
  name=strcat(fileName,'_',it);
  h_h=findobj('Tag','VillMachPic');

  if ~(isempty(h_h))
    print( h_h, '-deps',name)
    v=[0 0 0.5];
    h_h=findobj(gcf,'Tag','EPS');
    set(h_h,'ForegroundColor',v); 
    eps_comment(1)={'The current picture has been saved in the EPS file called:'};
    eps_comment(2)={strcat(name,'.eps')};
    eps_comment(3)={'in the current directory.'};
    text_out(eps_comment); 
  else
    T_T={'Can not find figure to create EPS file from!'};
    text_out(T_T,[0.5 0 0]);
  end;
%----------
case 'Exit'
%----------
   %==close editor if exists
   thisTag=get(gcf,'Tag');
   maskedTag=strcat('maskeditor',thisTag);
   FigureHndl=findobj('Tag',maskedTag);
  
   if ~isempty(FigureHndl)
      close(FigureHndl);
   end;
   %---close this
   close(gcf);

   h_h=findobj('Tag','VillMachPic');
   if ~(isempty(h_h))
      close(h_h);
   end;
   disp('Hope you had fun!');

end %switch callingObject


%=============help stuff===================

%---------------------------------------
function setup_Filelist(nowdir1, direct)
%---------------------------------------

do=strcat(nowdir1, '/default.m');
defaultStruct=dir(do);
do=strcat(nowdir1, '/',direct,'/*.m');
fileListStruct=dir(do);
fileList={defaultStruct.name, fileListStruct.name,'zzzzzzzzzzzzzz'};
s_s=size(fileList);
s_s=s_s(2);
fileListHndl=findobj(gcf,'Tag','FileListBox');
if (s_s==0) 
   T_T=('WARNING: No data found in current directory!'); 
   text_out(T_T,[0.5 0 0],1);
   return;
else
   fileList=sort(fileList);
   fileList(s_s)=cell(1,1);
   set(fileListHndl,'String',fileList);
   set(fileListHndl,'Value',1); %s_s
end;


%---------------------------------------------------------------
function result_out(index_A_A,no_ev,spec_rad,EW_M,r_regular,interpol_str,time_str);
%----------------------------------------------------------------
%index_A_A
%no_ev
%spec_rad
%EW_M
if (index_A_A==0)
  T_T={'WARNING: the set [N1,N2]x[N1,N2] is too small.'...
       'Enter new parameters N1 and N2 above.' ' '};
  text_out(T_T,[0.5 0 0]);

elseif (no_ev==0)
 T_T={'No estimation of the lower bound for the Hoelder regularity '...
      'possible, because none of the eigenvectors is in the set V_r !' ' '};
  text_out(T_T);

elseif (spec_rad==0)
 T_T={'The spectral radius is zero, therefore the estimated lower bound '...
      'for the Hoelder regularity would become infinity !!!' ' '};
  text_out(T_T);

elseif (EW_M==0)
  T_T={'WARNING: division by zero. (Natural logarithm of 1 !)'...
       'Enter a new dilation matrix M. (The absolute value of the largest'...
       'eigenvalue of the above dilation matrix is 1).' ' '};
  text_out(T_T,[0.5 0 0]);
 
else
  r_regular_str=num2str(r_regular);
  do=strcat(r_regular_str,' =  estimated lower bound for the Hoelder regularity.'); 
  dod=('    '); 
  do1=('Total time needed for calculation of the lower bound'); 
  do2=('(incl. examination of interpolation):'); 
  do3=strcat(time_str , ' minutes.');
  ddo={do,interpol_str,dod,do1,do2,do3};
  text_out(ddo);
 
end 


%----------------------
function standard_out_gen
%----------------------

T_T={...
'>First choose the dimension by pressing 1D or 2D.' ... 
'>Then choose one of the masks in the list by clicking on it.' ...
' Information on what you have chosen will be displayed in this' ' window.' ...
'>Now set the parameters and click on GO. The result will be' ' displayed here.' ...
' ' 'Click on HELP to get more information how to use this tool.'};
hh=findobj(gcf,'Tag','TextBox');
v=[0 0 0.5];
set(hh,'ForegroundColor',v);
set(hh,'String', T_T);
set(hh,'Value',1);


%----------------------
function standard_out
%----------------------

T_T={...
'>Then choose one of the masks in the list by clicking on it.' ...
' Information on what you have chosen will be displayed in this' ... 
' window.' ...
'>Now set the parameters and click on GO. The result will be' ...
' displayed here.' ...
'>To change the dimension, press the 1D or 2D buttons above.' ...
' ' 'Click on HELP to get more information how to use this tool.'};
       
hh=findobj(gcf,'Tag','TextBox');
v=[0 0 0.5];
set(hh,'ForegroundColor',v);
set(hh,'String', T_T);
set(hh,'Value',1);


%----------------------
function text_out(out_text,out_color, out_value);
%----------------------

if (nargin<=2) out_value=1; end;
if (nargin<=1) out_color=[0 0 0.5]; end;
if (nargin==0) out_text=''; end;

hh=findobj(gcf,'Tag','TextBox');
set(hh,'ForegroundColor',out_color);
set(hh,'String', out_text);
set(hh,'Value',out_value);


%----------------------
function textwin_on
%----------------------
h_h=findobj(gcf,'Tag','TextBox');
set(h_h,'Visible','on');

h_h=findobj(gcf,'Tag','Plotwin');
set(h_h,'Visible','off');

h_h=findobj(gcf,'Tag','Plot');
set(h_h,'String','Plot function');

h_h=findobj(gcf,'Tag','Plot_scalingVector');
set(h_h,'String','Plot scaling vector');

%set(h_h,'Visible','off');

%=============EOF==========================================














